/*********************************************************************
本ソースリストおよびソフトウェアは、ライセンスフリーです。
利用、編集、再配布等が自由に行えますが、著作権表示の改変は禁止します。

                               Copyright (c) 2011 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/
// Arduino 0022 ＋ Duemilanove で動作確認しています。

#define LED_IR_PORT 12      // 赤外線LED接続ポート
#define LED_L_PORT 9        // 左目用LED
#define LED_R_PORT 8        // 右目用LED
#define SW_PORT 0           // 飛び出しスイッチ(LOWで反転=飛び出し)
#define FLASH_DELAY_off 550 // 切り換え信号送出後に表示を消すまでの待ち時間[us]
#define FLASH_DELAY_on  650 // 上記の後に次の表示を行うまでの待ち時間

void setup(){
  Serial.begin(9600);
  pinMode(LED_IR_PORT, OUTPUT);
  pinMode(SW_PORT, INPUT);
  digitalWrite(SW_PORT, HIGH);  // プルアップ
}

void loop(){
  unsigned long time;
  //  unsigned int FLASH_DELAY_in;
  Serial.println("started");  
  time=micros()+1000000;    //1sec
  while( time > micros() ){
    while( time > micros() );
    time += 8400;
    ir_tx( 0xD7,0x0C);                 // 左目表示切り換え信号送出 1110 1011 0011 0000
    delayMicroseconds( FLASH_DELAY_off );
    // 表示の消去
    digitalWrite(LED_L_PORT, LOW);
    digitalWrite(LED_R_PORT, LOW);
    delayMicroseconds( FLASH_DELAY_on );
    // 左目用の表示
    if( digitalRead(SW_PORT)==HIGH ) digitalWrite(LED_L_PORT, HIGH);  // 通常時：奥まった映像
    else digitalWrite(LED_R_PORT, HIGH);                              // 反転時：飛び出し映像
    while( time > micros() );
    time += 8400;
    ir_tx( 0x17,0x33 );                // 右目表示切り換え信号送出 1110 1000 1100 1100
    delayMicroseconds( FLASH_DELAY_off );
    // 表示の消去
    digitalWrite(LED_L_PORT, LOW);
    digitalWrite(LED_R_PORT, LOW);
    delayMicroseconds( FLASH_DELAY_on );
    // 右目用の表示
    if( digitalRead(SW_PORT)==HIGH ) digitalWrite(LED_R_PORT, HIGH);  // 通常時：奥まった映像
    else digitalWrite(LED_L_PORT, HIGH);                              // 反転時：飛び出し映像
//    FLASH_DELAY_in = 1 + analogRead(0);
  }
  Serial.println("sttoped");  
}

void ir_tx(unsigned char tx1, unsigned char tx2){
  unsigned long time_sym;
  unsigned char i;
  
  time_sym=micros()+40;
  for( i=0 ; i<8 ; i++){
    if( (tx1>>i)&0x01 == 0x01 ){
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, HIGH);
      time_sym += 20;
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, LOW);
      time_sym += 20;
    }else{
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, LOW);
      time_sym += 40;
    }
  }
  for( i=0 ; i<8 ; i++){
    if( (tx2>>i)&0x01 == 0x01 ){
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, HIGH);
      time_sym += 20;
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, LOW);
      time_sym += 20;
    }else{
      while( time_sym > micros() );
      digitalWrite(LED_IR_PORT, LOW);
      time_sym += 40;
    }
  }
  while( time_sym > micros() );
}

